<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <s:div id="globalDiv">
                <h1><span class="fa fa-wrench" style="font-size: 1em;"/>
                    #{messages['gazelle.dds.DefinitionOfApplicationPreferences']}
                </h1>
                <s:decorate id="addPrefDeco" template="/layout/panels/_panel_title_id.xhtml"
                            rendered="#{applicationManager.preference != null}">
                    <ui:param name="panel_id" value="addPrefPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['gazelle.dds.NewApplicationPreference']}"/>
                    </ui:define>

                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="preferenceNameInput"/>
                        <ui:define name="label">#{messages['gazelle.dds.PreferenceName']}</ui:define>
                        <h:inputText id="preferenceNameInput" value="#{applicationManager.preference.variable}"
                                     size="50" required="true"
                                     styleClass=" form-control">
                            <a4j:ajax event="blur" render="addPrefDeco" execute="@this"
                                      listener="#{applicationManager.isValidPrefName()}"/>
                        </h:inputText>
                    </s:decorate>
                    <s:decorate template="/layout/form/_edit.xhtml">
                        <ui:param name="id" value="valueInput"/>
                        <ui:define name="label">#{messages['gazelle.dds.Value']}</ui:define>
                        <h:inputText id="valueInput" value="#{applicationManager.preference.value}" size="50"
                                     styleClass=" form-control"/>
                    </s:decorate>
                    <a4j:commandButton value="#{messages['gazelle.simulator.Save']}" styleClass="gzl-btn-green"
                                       actionListener="#{applicationManager.savePreference(applicationManager.preference)}"
                                       disabled="#{!applicationManager.validPref}"
                                       render="globalDiv"/>
                </s:decorate>
                <p>
                    <a4j:commandButton value="#{messages['gazelle.dds.AddAPreference']}" styleClass="gzl-btn-blue"
                                       actionListener="#{applicationManager.createNewPreference()}"
                                       rendered="#{applicationManager.preference == null}" render="globalDiv"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.maven.ResetSecurityPreferences']}"
                                       actionListener="#{applicationManager.resetHttpHeaders()}"
                                       styleClass="gzl-btn-blue"
                                       rendered="#{applicationManager.preference == null}" render="globalDiv"/>
                </p>

                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="prefPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.maven.ApplicationPreferences']}"/>
                    </ui:define>
                    <rich:dataTable id="prefList" value="#{applicationManager.getAllPreferences()}" var="pref"
                                    render="ds"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.dds.PreferenceName']}</ui:define>
                            <h:outputText value="#{pref.variable}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.dds.PreferenceValue']}</ui:define>
                            <rich:inplaceInput value="#{pref.value}"
                                               defaultLabel="#{messages['gazelle.dds.PreferenceValue_2']}"
                                               showControls="true" size="16">
                                <a4j:ajax event="change" render="globalDiv"
                                          listener="#{applicationManager.savePreference(pref)}"/>
                            </rich:inplaceInput>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>
                            <div class="gzl-never-wrap form-control-static">
                                <a4j:commandLink event="click" title="#{messages['net.ihe.gazelle.maven.Delete']}"
                                                 oncomplete="jq162('#delPrefModal').modal('show');"
                                                 render=" :prefOutputs" execute="@this"
                                                 actionListener="#{applicationManager.setPreference(pref) }">
                                    <span class="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="prefList"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </ui:decorate>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="delPrefModal"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.maven.RemovePreference']}"/>
                    </ui:define>

                    <s:div id="prefOutputs" styleClass="form-horizontal">
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.maven.PreferenceNameuniqueKey']})
                            </ui:define>
                            <h:outputText value="#{applicationManager.preference.variable}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['gazelle.dds.PreferenceValue']}</ui:define>
                            <h:outputText value="#{applicationManager.preference.value}"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['net.ihe.gazelle.maven.Cancel']}"
                                           actionListener="#{applicationManager.setPreference(null)}"
                                           oncomplete="jq162('#delPrefModal').modal('hide')"/>
                        <a4j:commandButton styleClass="gzl-btn-red"
                                           value="#{messages['net.ihe.gazelle.maven.Remove']}"
                                           action="#{applicationManager.removeSelectedPreference()}"
                                           oncomplete="jq162('#delPrefModal').modal('hide')"
                                           render="prefList"/>
                    </ui:define>
                </ui:decorate>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
